dim arrPCs()
dim arrSinglePC(3)
dim SinglePC
dim counter, i, j
dim machine, username, macaddress, ipaddress

' Liste der PCs, die angepingt werden sollen
PCListe = "PCListe_komplett.txt"

' Liste der PCs, die auf den Ping reagiert haben
PCsOnline = "PCs_Online.log"

' Liste der PCs, die auf den Ping reagiert haben und an denen ein Benutzer angemeldet ist
PCsOnlineUser = "PCs_Online_User.log"

' Liste der PCs, die auf den Ping nicht reagieren
PCsOffline = "PCs_Offline.log"

' Liste aller PCs mit MAC- und IP-Adresse
PCsKomplett = "PCs_Komplett.log"


set objFSO = CreateObject("Scripting.FileSystemObject")

' altes LogFile einlesen
Set objLogFileKomplett = objFSO.GetFile(PCsKomplett)
' Logfile ist nicht leer -> auslesen
if objLogFileKomplett.Size <> 0 Then

  Set objLogFileKomplett = nothing
  Set objLogFileKomplett = objFSO.OpenTextFile(PCsKomplett, 1)

  counter = 0
  Do While objLogFileKomplett.AtEndOfStream <> True
    counter = counter + 1 
    redim preserve arrPCs(counter)
    zeile = trim(objLogFileKomplett.Readline)
    arrZeile = split(zeile, ";") 
    arrPCs(counter) = arrZeile
  Loop
  objLogFileKomplett.Close

' Logfile ist leer -> leeres Array erstellen
else

  Set objLogFileKomplett = nothing
  redim preserve arrPCs(0)

end if

' brige LogFiles ffnen
Set objTextFile = objFSO.OpenTextFile(PCListe, 1)
Set objLogFileOn = objFSO.OpenTextFile(PCsOnline, 2, true)
Set objLogFileOnUser = objFSO.OpenTextFile(PCsOnlineUser, 2, true)
Set objLogFileOff = objFSO.OpenTextFile(PCsOffline, 2, true)

Do While objTextFile.AtEndOfStream <> True

    arrSinglePC(0) = ""
    arrSinglePC(1) = ""
    arrSinglePC(2) = ""
    arrSinglePC(3) = ""
    machine = ""
    username = ""
    ipaddress = ""
    macaddress = ""
    
    machine = trim(objtextFile.Readline)

    ' auskommentierte Zeilen berlesen
    if left(machine, 1) <> ";" Then

    wscript.echo machine & ": wird angepingt und ausgelesen..."
    
    ' PC anpingen
    Set objPing = GetObject("winmgmts:{impersonationLevel=impersonate}")._
        ExecQuery("select * from Win32_PingStatus where address = '"_
            & machine & "'")
    For Each objStatus in objPing
        ' PC antwortet nicht
        If IsNull(objStatus.StatusCode) or objStatus.StatusCode <> 0 Then 
	        ' MAC- und IP-Adresse aus Datei lesen
          index = in_array(arrPCs, machine)
	        if index <> -1 Then
	          SinglePC = arrPCs(index)
            objLogFileOff.Write(machine & ";" & SinglePC(1) & ";" & SinglePC(2) & vbCrlf)
          else
            objLogFileOff.Write(machine & ";;" & vbCrlf)
	        end if
        ' PC antwortet
        Else 
          ' Verbindung zum PC herstellen
          Set objWMIService = GetObject("winmgmts:" _
          & "{impersonationLevel=impersonate}!\\" & machine & "\root\cimv2") 
  
          ' Benutzernamen auslesen
          Set colComputer = objWMIService.ExecQuery _
            ("Select * from Win32_ComputerSystem")
 
          For Each objComputer in colComputer
            if objComputer.UserName <> "" Then
              username = replace(objComputer.UserName, "AO-DOM\", "")
  	          objLogFileOnUser.Write(machine & ";" & username & vbCrlf)
  	        else
  	          objLogFileOn.Write(machine & vbCrlf)
            end if
          Next    

          ' IP- und MAC-Adresse auslesen
 	        Set colAdapters = objWMIService.ExecQuery("SELECT * FROM Win32_NetworkAdapterConfiguration WHERE IPEnabled = True")
	        For Each objAdapter in colAdapters
            macaddress = objAdapter.MACAddress
            if Not IsNull(objAdapter.IPAddress) Then
              ipaddress = join(objAdapter.IPAddress)
            End If
          Next
        End If
    Next
    
    arrSinglePC(0) = machine
    arrSinglePC(1) = macaddress
    arrSinglePC(2) = ipaddress
    arrSinglePC(3) = username
    
    ' gibt es schon einen alten Eintrag fr den PC?
    index = in_array(arrPCs, machine)
    
    ' es gibt einen alten Eintrag
    if index <> -1 Then
    
      ' alten Datensatz lesen  
      SinglePC = arrPCs(index)
      
      if SinglePC(1) = "" Then
        arrSinglePC(1) = macaddress
      else
        if macaddress <> "" Then
          arrSinglePC(1) = macaddress
        else
          arrSinglePC(1) = SinglePC(1)
        end if
      end if    
      if SinglePC(2) = "" Then
        arrSinglePC(2) = ipaddress
      else
        if ipaddress <> "" Then
          arrSinglePC(2) = ipaddress
        else
          arrSinglePC(2) = SinglePC(2)
        end if
      end if    
      if SinglePC(3) = "" Then
        arrSinglePC(3) = username
      else
        if username <> "" Then
          arrSinglePC(3) = username
        else
          arrSinglePC(3) = SinglePC(3)
        end if
      end if    

      arrPCs(index) = arrSinglePC

    ' es gibt keinen alten Eintrag
    else
      
      ' PC-Liste um eins erweitern
      redim preserve arrPCs(ubound(arrPCs) + 1)
      arrPCs(ubound(arrPCs)) = arrSinglePC
      
    end if
    
    end if ' Auskommentierung
    
Loop


' komplette Liste schreiben
Set objLogFileKomplett = objFSO.OpenTextFile(PCsKomplett, 2, true)

for i = 1 to ubound(arrPCs)
  SinglePC = arrPCs(i)
  for j = 0 to 3
    objLogFileKomplett.Write(SinglePC(j))
    if j <> 3 then
      objLogFileKomplett.Write(";")
    end if
  next
  objLogFileKomplett.Write(vbCrLf)
next

objLogFileKomplett.Close

' Objekte schlieen
objTextFile.Close
objLogFileOn.Close
objLogFileOff.Close



' Sucht einen PC-Namen in der alten LogDatei
function in_array(byref arr, byval str)
  dim i, arr2nd
  if ubound(arr) = 0 Then
    in_array = -1
    exit function
  end if
  for i = 1 to ubound(arr)
    arr2nd = arr(i)
    if arr2nd(0) = str then
      in_array = i
      exit function
    end if
  next
  in_array = -1
end function



